include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
axiom nat : Type[0].
axiom O : nat.
axiom filter_nat_type : \forall return_ : Type[0] . (nat -> return_) -> nat -> return_.
axiom axiom_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (equal) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ).
definition eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((axiom_filter_nat_type_O) (return_type)) (return_)).
definition sym_eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) (return_ (O) ) ((filter_nat_type) (return_type) return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((eq_filter_nat_type_O) (return_type)) (return_)).
axiom times : nat -> nat -> nat.
axiom times_body : nat -> nat -> nat.
axiom axiom_times : \forall (n:nat). (equal) (nat -> nat) ((times)  n) ((filter_nat_type) (nat -> nat) (times_body)  n).
definition eq_times : \forall (n:nat). (leibniz) (nat -> nat) ((times)  n) ((filter_nat_type) (nat -> nat) (times_body)  n) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((times)  n)) ((filter_nat_type) (nat -> nat) (times_body)  n)) ((axiom_times) (n)).
definition sym_eq_times : \forall (n:nat). (leibniz) (nat -> nat) ((filter_nat_type) (nat -> nat) (times_body)  n) ((times)  n) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((times)  n)) ((filter_nat_type) (nat -> nat) (times_body)  n)) ((eq_times) (n)).
axiom axiom_times_body_O : (equal) (nat -> nat) ((times_body)  (O) ) (\lambda m : nat. (O) ).
definition eq_times_body_O : (leibniz) (nat -> nat) ((times_body)  (O) ) (\lambda m : nat. (O) ) := ((((equal_leibniz) (nat -> nat)) ((times_body)  (O) )) (\lambda m : nat. (O) )) (axiom_times_body_O).
definition sym_eq_times_body_O : (leibniz) (nat -> nat) (\lambda m : nat. (O) ) ((times_body)  (O) ) := ((((sym_leibniz) (nat -> nat)) ((times_body)  (O) )) (\lambda m : nat. (O) )) (eq_times_body_O).
definition times_O_n : \forall (n:nat). (eq) (nat) (O)  ((times)  (O)  n) := \lambda n : nat. (((sym_eq_times) ((O) )) (\lambda y : nat -> nat. (eq) (nat) (O)  (y n))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) ((times_body) )) (\lambda y : nat -> nat. (eq) (nat) (O)  (y n))) (((sym_eq_times_body_O) (\lambda y : nat -> nat. (eq) (nat) (O)  (y n))) (((refl) (nat)) ((O) )))).
